#!/bin/bash

function usage {
	echo ""
	echo "Search/replace script"
	echo "Not enough parameters provided."
	echo "Usage: $0 searchstring replacestring [fileextension]"
	echo ""
}

#check for required parameters
if  [ -z "$2" ];
then
	usage
	exit
fi

#check for files argument
if  [ -z "$3" ];
then
	files=$(find . -type f)
else
	files=$(find . -name "*.$3" -type f)
fi

c=0
for f in $files;
do
	if grep -q "$1" $f;
	then
		cp $f $f.bak
		if [ $c -lt 1 ]; 
		then 
			echo "The string \"$1\" has been replaced with \"$2\" in:" 
		fi
		echo "$f"
		sed s/"$1"/"$2"/g < $f.bak > $f
		rm $f.bak
		c=`expr $c + 1`
	fi
done

if [ $c -lt 1 ];
then
	echo "No files found containing the string \"$1\""
fi